# GitLab CI - pipeline for containerization (Docker image)
---
include:
- local: .gitlab/ci/.stubs.yml
- template: Jobs/Container-Scanning.gitlab-ci.yml

stages:
- build
- test
- cleanup

review:
  stage: build
  extends: .build-image
  variables:
    TAG: mr${CI_MERGE_REQUEST_IID}
  environment:
    name: review/${TAG}
    url: ${CI_SERVER_URL}/${CI_PROJECT_PATH}/container_registry
    on_stop: stop-review
  rules:
  - if: $CI_MERGE_REQUEST_IID

stop-review:
  stage: cleanup
  extends: .delete-image
  variables:
    TAG: mr${CI_MERGE_REQUEST_IID}
  environment:
    name: review/${TAG}
    action: stop
  when: manual
  needs:
  - review
  rules:
  - if: $CI_MERGE_REQUEST_IID

edge:
  stage: build
  extends: .build-image
  variables:
    TAG: main
  rules:
  - if: $CI_COMMIT_BRANCH == $CI_DEFAULT_BRANCH

stable:
  stage: build
  extends: .build-image
  variables:
    PACKAGE: charmed-django==${CI_COMMIT_TAG}
    TAG: ${CI_COMMIT_TAG}
  after_script:
  - docker tag ${IMAGE}:${TAG} ${IMAGE}:latest
  - docker push ${IMAGE}:latest
  rules:
  - if: $CI_COMMIT_TAG

django:
  stage: test
  image: ${CI_REGISTRY_IMAGE}:${CI_COMMIT_REF_NAME}
  before_script: |
    manage.py collectstatic --noinput --link
    pip install wget --no-cache-dir --target=.
    run_with_ctrl_c() { ${@:1:$#-1} & sleep 1 && python -m wget http://${@:(-1)} && kill -INT $!; }
  script: |
    echo "${TEST_COMMAND}"
    ${TEST_COMMAND}
  parallel:
    matrix:
    - TEST_COMMAND:
      - pip show charmed-django
      - manage.py --help
      - manage.py check
      - run_with_ctrl_c gunicorn application.wsgi 0.0.0.0:8000
  variables:
    GIT_STRATEGY: none
    DJANGO_ALLOWED_HOSTS: '*'
    DJANGO_DATABASE_URL: sqlite://
    DJANGO_SECRET_KEY: testing
  rules:
  - if: $CI_COMMIT_BRANCH == $CI_DEFAULT_BRANCH || $CI_COMMIT_TAG

django-review:
  extends: django
  image: ${CI_REGISTRY_IMAGE}:mr${CI_MERGE_REQUEST_IID}
  rules:
  - if: $CI_MERGE_REQUEST_IID

container_scanning:
  variables:
    GIT_STRATEGY: fetch
  rules:
  - if: $CI_MERGE_REQUEST_IID
    variables:
      CS_IMAGE: ${CI_REGISTRY_IMAGE}:mr${CI_MERGE_REQUEST_IID}
  - if: $CI_COMMIT_BRANCH == $CI_DEFAULT_BRANCH || $CI_COMMIT_TAG
    variables:
      CS_IMAGE: ${CI_REGISTRY_IMAGE}:${CI_COMMIT_REF_NAME}
